Bugzilla will be upgraded to version 5.0 on a still to be determined date in the near future. The original upgrade date has been delayed.
Bug 1398355 - Review Request: php-ast - Abstract Syntax Tree
Review Request: php-ast - Abstract Syntax Tree
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: François Kooman
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2016-11-24 09:26 EST by Remi Collet
Modified: 2016-12-03 21:25 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-12-03 21:25:00 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
fkooman: fedora‑review+


Attachments (Terms of Use)
phpci log (26.24 KB, text/plain)
2016-11-24 11:57 EST, François Kooman
no flags Details

  None (edit)
Description Remi Collet 2016-11-24 09:26:27 EST
Spec URL: https://raw.githubusercontent.com/remicollet/remirepo/2757da8cd004ee82831da2e1c11218912e04087e/php/php-ast/php-ast.spec
SRPM URL: http://rpms.remirepo.net/SRPMS/php-ast-0.1.2-1.remi.src.rpm
Description: 
This extension exposes the abstract syntax tree generated by PHP 7.


Fedora Account System Username: remi
Comment 1 François Kooman 2016-11-24 11:56:56 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (2 clause)", "Unknown or generated". 48 files have unknown
     license. Detailed output of licensecheck in /home/fedora/1398355-php-
     ast/licensecheck.txt

**NOTE**: the spec file says "PHP" license, while the GH repository says BSD-3-Clause. Strangely enough 'fedora-review' thinks BSD-2-Clause...

[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.

**NOTE**: /usr/share/doc/php-ast/scripts/generate_ast_data.php used preg_match, which may require the php-pcre requires? It is part of php-common though.

[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 5 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in php-ast-
     debuginfo

**NOTE**: is guess debuginfo packages do not need to depend on their base package? Can't find anything about this in packaging guidelines, also the debuginfo package is automatically generated...

[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.

**NOTE** the (empty) EXPERIMENTAL file is packaged, is that really needed? I doesn't add much...

[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.

PHP:
[x]: Run phpci static analyze on all php files.
     Note: phpCompatInfo version 5.0.1 DB version 1.14.0 built Oct 17 2016
     08:05:57 CEST static analyze results in /home/fedora/1398355-php-
     ast/phpci.log


Rpmlint
-------
Checking: php-ast-0.1.2-1.fc26.x86_64.rpm
          php-ast-debuginfo-0.1.2-1.fc26.x86_64.rpm
          php-ast-0.1.2-1.fc26.src.rpm
php-ast.x86_64: E: zero-length /usr/share/doc/php-ast/EXPERIMENTAL
3 packages and 0 specfiles checked; 1 errors, 0 warnings.




Rpmlint (debuginfo)
-------------------
Checking: php-ast-debuginfo-0.1.2-1.fc26.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
php-ast.x86_64: E: zero-length /usr/share/doc/php-ast/EXPERIMENTAL
2 packages and 0 specfiles checked; 1 errors, 0 warnings.



Requires
--------
php-ast (rpmlib, GLIBC filtered):
    config(php-ast)
    libc.so.6()(64bit)
    php(api)
    php(zend-abi)
    php-tokenizer(x86-64)
    rtld(GNU_HASH)

php-ast-debuginfo (rpmlib, GLIBC filtered):



Provides
--------
php-ast:
    config(php-ast)
    php-ast
    php-ast(x86-64)

php-ast-debuginfo:
    php-ast-debuginfo
    php-ast-debuginfo(x86-64)



Unversioned so-files
--------------------
php-ast: /usr/lib64/php-zts/modules/ast.so
php-ast: /usr/lib64/php/modules/ast.so

Source checksums
----------------
https://github.com/nikic/php-ast/archive/abfef40846cb5454dafa1808769fde851ba8dd70/php-ast-0.1.2-abfef40.tar.gz :
  CHECKSUM(SHA256) this package     : 7b6eef07b7370a54ebfd2bb0cfde9a4f8013e6a68a8d8e4d7a6e0de84977380a
  CHECKSUM(SHA256) upstream package : 7b6eef07b7370a54ebfd2bb0cfde9a4f8013e6a68a8d8e4d7a6e0de84977380a


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1398355
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, PHP, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 2 François Kooman 2016-11-24 11:57 EST
Created attachment 1223937 [details]
phpci log
Comment 3 Remi Collet 2016-11-24 12:45:17 EST
Thanks for the review.


[!]: License field in the package spec file matches the actual license.

Good catch
Fixed in the spec (BSD)

[!]: Requires correct, justified where necessary.

Only %doc, not installed in an usable way.

+ EXPERIMENTAL file dropped

See: https://github.com/remicollet/remirepo/commit/6ecc58052920338c061a0b35dcb1e6497786b63b

Spec: https://raw.githubusercontent.com/remicollet/remirepo/6ecc58052920338c061a0b35dcb1e6497786b63b/php/php-ast/php-ast.spec
Srpm: http://rpms.remirepo.net/SRPMS/php-ast-0.1.2-1.remi.src.rpm
Comment 5 François Kooman 2016-11-25 07:00:08 EST
Looks good! Approved.
Comment 6 Remi Collet 2016-11-25 07:04:14 EST
Thanks.

New package requested on pkgdb2.
Comment 7 Gwyn Ciesla 2016-11-28 09:18:27 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/php-ast
Comment 8 Fedora Update System 2016-11-28 10:37:40 EST
php-ast-0.1.2-2.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2016-48d3002507
Comment 9 Fedora Update System 2016-12-02 13:54:16 EST
php-ast-0.1.2-2.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-48d3002507
Comment 10 Fedora Update System 2016-12-03 21:25:00 EST
php-ast-0.1.2-2.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.